const rot = require('bitwise-rotation').rorInt32

const a = 0x67e6096a
const b = 0x85ae67bb
const c = 0x72f36e3c
const d = 0x3af54fa5
const e = 0x7f520e51
const f = 0x8c68059b
const g = 0xabd9831f
const h = 0x19cde05b

const t = new Uint32Array(5)

t[0] = 0x5be0cd19
t[1] = 0x3587272b
t[2] = 0x1f85c98c
t[3] = 0x428a2f98
t[4] = 0x61626380

const output = t[0] + t[1] + t[2] + t[3] + t[4]
console.log(t[0] , t[1] , t[2] , t[3] , t[4])
console.log(output.toString(16))

const ch = ((e&f) ^ ((e^-1)&g))
const maj = ((a&b) ^ (b&c) ^ (c&a))
const bigsig0 = (rot(a, 2) ^ rot(a,13) ^ rot(a,22))
const bigsig1 = (rot(e, 6) ^ rot(e, 11) ^ rot(e, 25))

const T1 = h + bigsig1 + ch + 0x982f8a42 + 0x80636261
const T2 = bigsig0 + maj

const result = new Uint32Array(12)

result[0] = ch
result[1] = maj
result[2] = bigsig0
result[3] = bigsig1
result[4] = T1
result[5] = T2
result[6] = T1 + T2
result[7] = d + T1
result[8] = 0x22462afa - d
result[9] = 0xabd9831f - result[8]
result[10] = result[9] - result[1]
result[11] = result[9] - result[2]


const labels = [
  'ch',
  'maj',
  'bigsig0',
  'bigsig1',
  'T1',
  'T2',
  'new a = T1 + T2',
  'new e = d + T1',
  'expected T1',
  'expected T2'
]

for (let i = 0; i < result.length; i++) {
  console.log(Buffer.from(result.buffer.slice(4*i, 4*(i+1))), labels[i])
}
